﻿<%@ Page Language="vb" AutoEventWireup="false" CodeBehind="Default.aspx.vb" Inherits="ClientAPI._Default" %><%@ Register Assembly="MindFusion.Scheduling.WebForms" Namespace="MindFusion.Scheduling.WebForms"
	TagPrefix="MindFusion" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head id="Head1" runat="server">
	<title>MindFusion WebPlanner Sample - Client API</title>
	<link href="common/jquery-ui.min.css" rel="stylesheet" />
	<link href="common/samples.css" rel="stylesheet" />
	<script type="text/javascript" src="common/jquery.min.js"></script>
	<script type="text/javascript" src="common/jquery-ui.min.js"></script>
	<script type="text/javascript" src="common/samples.js"></script>
	<style type="text/css">
		.controls
		{
			width: 960px;
			margin-top: 10px;
			display:inline;
		}
		.cheader
		{
			display: inline-block;
			text-decoration: underline;
			margin-right: 10px;
		}
		#TextArea1
		{
			width: 959px;
			height: 79px;
		}
		div.controls > .ui-selectmenu-button
		{
			top: 8px;
		}
		div.controls > .ui-button
		{
			top: -3px;
		}
	</style>
</head>
<body>
	<form id="form2" runat="server">
	<asp:ScriptManager ID="ScriptManager2" runat="server">
	</asp:ScriptManager>
	<input type="hidden" id="collapsed" runat="server" />
	<div id="header" style="height: 49px;">
		<div style="float: left; margin-right: 5px;">
			<span class="label">View:</span>
			<asp:DropDownList ID="ddlChangeView" runat="server" AutoPostBack="true" OnSelectedIndexChanged="ddlChangeView_SelectedIndexChanged">
				<asp:ListItem Selected="True" Text="SingleMonth" />
				<asp:ListItem Text="MonthRange" />
				<asp:ListItem Text="WeekRange" />
				<asp:ListItem Text="SingleWeek" />
				<asp:ListItem Text="Horizontal List" />
				<asp:ListItem Text="Vertical List" />
				<asp:ListItem Text="Vertical Timetable" />
				<asp:ListItem Text="Horizontal Timetable" />
				<asp:ListItem Text="ResourceView"></asp:ListItem>
			</asp:DropDownList>
		</div>
		<div style="float: left; margin-right: 5px;">
			<span class="label">Grouping:</span>
			<asp:DropDownList ID="ddlGroupType" runat="server" AutoPostBack="true" OnSelectedIndexChanged="ddlGroupType_SelectedIndexChanged">
				<asp:ListItem Selected="True">None</asp:ListItem>
				<asp:ListItem>GroupByContacts</asp:ListItem>
				<asp:ListItem>GroupByLocations</asp:ListItem>
				<asp:ListItem>GroupByTasks</asp:ListItem>
				<asp:ListItem>GroupByResource</asp:ListItem>
			</asp:DropDownList>
		</div>
		<div style="float: left; margin-top: 20px;">
			<input id="Button14" type="button" value="postback" onclick="return Button14_onclick()" /></div>
		<div style="float: right; margin-right: 5px; margin-top: 17px;">
			<button id="expandButton" onclick="onExpandCollapse()">
				&gt;</button>
		</div>
	</div>
	<div id="info" style="top: 60px; bottom: 24px;">
		<div id="infoTab" style="padding: 10px;">
			<h1>
				About this sample</h1>
			<p>
				This sample demonstrates some of the client API available in WebPlanner. The buttons
				in Cell, Selection and Item sections call the corresponding Calendar method. Use
				the Parameters section to supply the needed parameters. Hover the controls to see
				the method's signature and description.
			</p>
		</div>
	</div>
	<div id="content" style="top: 60px; bottom: 24px;">
		<div style="position: absolute; left: 0px; top: 0px; bottom: 0px; right: 0px">
			<div style="position: absolute; left: 0px; top: 0px; right: 0px; height: 309px; background-color: #fafafa;
				border-bottom: 1px solid #e2e4e7; border-right: 1px solid #e2e4e7; padding: 5px;">
				<div class="controls">
					<div class="controls">
						<p class="cheader">
							Parameters</p>
						<asp:Label ID="Label6" runat="server" Text="Start date (dd.MM.yyyy)"></asp:Label><input
							id="txtStartDate" type="text" maxlength="10" style="width: 70px" />
						<asp:Label ID="Label4" runat="server" Text="time"></asp:Label><input id="txtStartTime"
							type="text" maxlength="5" style="width: 40px" />
						<asp:Label ID="Label7" runat="server" Text="End date (dd.MM.yyyy)"></asp:Label><input
							id="txtEndDate" type="text" maxlength="10" style="width: 70px" />
						<asp:Label ID="Label5" runat="server" Text="time"></asp:Label><input id="txtEndTime"
							type="text" maxlength="5" style="width: 40px" />
						<asp:Label ID="Label2" runat="server" Text="isEndTime"></asp:Label><input id="chkEndTime"
							type="checkbox" />
						<asp:Label ID="Label8" runat="server" Text="Resource"></asp:Label>
						<select id="txtResources">
							<option></option>
						</select>
					</div><br />
					<div id="controlsRow">
						<div class="controls">
							<p class="cheader">
								Cell methods</p>
							<input id="Button1" type="button" value="getTimeCell" onclick="return Button1_onclick()"
								title="(dateTime, [isEndTime, [resource]]) returns the cell that corresponds the specified DateTime and resource." />
							<input id="Button2" type="button" value="getTimeCells" onclick="return Button2_onclick()"
								title="(startTime, [endTime, [isEndTime, [resource]]]) returns the collection of cells that correspond to the specified DateTime range and resource." />
							<input id="Button13" type="button" value="getAllDayCells" onclick="return Button13_onclick()"
								title="([startTime, [endTime, [resource]]]) returns the collection of all-day calendar cells in the Timetable view." />
							<asp:Label ID="Label11" runat="server" Text="getCellAt"></asp:Label><input id="chkGetCell"
								type="checkbox" checked="checked" title="(x,y) returns the cell that contains the specified coordinates" />
							<input id="Button5" type="button" value="Clear marked cells" title="clears the cells marked by the above methods"
								onclick="return Button5_onclick()" />
						</div><br />
						<div class="controls">
							<p class="cheader">
								Selection methods</p>
							<input id="Button3" type="button" value="getSelection" onclick="return Button3_onclick()"
								title="returns an object, containing the start and end DateTime of the current selection" />
							<input id="Button4" type="button" value="setSelection" onclick="return Button4_onclick()"
								title="(start, [end, [resource]]) sets the current time selection" />
							<input id="Button6" type="button" value="clearSelection" onclick="return Button6_onclick()"
								title="clears the current time selection" />
						</div><br />
						<div class="controls">
							<p class="cheader">
								Item methods</p>
							<input id="Button7" type="button" value="createItem" onclick="return Button7_onclick()"
								title="(args) creates a new item. Use the date inputs and the controls in Items section to supply data for the item" />
							<input id="Button8" type="button" value="createItem (recurrent)" onclick="return Button8_onclick()"
								title="(args) creates a new item. Use the date inputs and the controls in Items section to supply data for the item" />
							<input id="Button9" type="button" value="editItem" onclick="return Button9_onclick()"
								title="(item, args) edits the item. Use the date inputs and the controls in Items section to supply data for the item" />
							<asp:Label ID="Label10" runat="server" Text="Contact"></asp:Label>
							<select id="txtUserContact">
								<option></option>
							</select>
							<asp:Label ID="Label9" runat="server" Text="Location"></asp:Label>
							<select id="txtUserLocation">
								<option></option>
							</select>
							<input id="Button10" type="button" value="deleteItem" onclick="return Button10_onclick()"
								title="(item) deletes the item. Select an item to be deleted" />
							<input id="Button11" type="button" value="cloneItem" onclick="return Button11_onclick()"
								title="(item) clones the item. Select an item to be cloned" />
						</div><br />
						<div class="controls">
							<textarea cols="1" rows="4" id="txtInfo" style="width: 900px; height: 60px;" title="click on a calendar cell to see counts returned by Calendar's getCellItems, getCueCellItems, getHeaderItems and getCueHeaderItems methods"></textarea>
						</div>
					</div>
				</div>
			</div>
			<div style="position: absolute; left: 0px; top: 270px; right: 0px; bottom: 0px">
				<MindFusion:Calendar ID="Calendar1" runat="server" Width="100%" Height="100%" Theme="Silver"
					CalendarLoadScript="onCalendarLoad" DateClickScript="onDateClick" DateHeaderClickScript="onDateClick"
					ClickScript="onCalendarClick">
				</MindFusion:Calendar>
			</div>
		</div>
	</div>
	<div id="footer" style="height: 24px;">
		<span id="copyright"></span>
	</div>
	<script type="text/javascript">
		$('#ddlChangeView,#ddlGroupType').on("selectmenuchange", function ()
		{
			__doPostBack();
		});
		// creates a new MindFusion.Common.DateTime object from date and time strings.
		function dateFromString(dateString, timeString)
		{
			return new MindFusion.Common.DateTime.fromDateParts(
	        +dateString.substring(6, 10),
	        +dateString.substring(3, 5) - 1,
	        +dateString.substring(0, 2),
	        +timeString.substring(0, 2),
	        +timeString.substring(3, 5)
	        );
		}

		// the CalendarLoad event is raised after the calendar is initialized on the client side. 
		function onCalendarLoad(sender)
		{

			// get the current date of the Calendar and set the values of the date/time inputs.
			var date = sender.getDate();

			var txtStart = $get('txtStartDate');
			txtStart.value = date.toString('dd.MM.yyyy');

			var txtStartTime = $get('txtStartTime');
			txtStartTime.value = date.toString('hh:mm');

			var txtEnd = $get('txtEndDate');
			txtEnd.value = date.toString('dd.MM.yyyy');

			var txtEndTime = $get('txtEndTime');
			txtEndTime.value = date.toString('hh:mm');

			// get the calendar's resource collections and fill the values of the resource drop-downs accordingly.
			var txtRes = $get('txtResources');
			var txtUserContact = $get('txtUserContact');
			var txtUserLocation = $get('txtUserLocation');
			var collections = sender.getResourceCollections();

			for (var i = 0, l = collections.contacts.length; i < l; i++)
			{
				var option = document.createElement("OPTION");
				option.text = collections.contacts[i].firstName + ' ' + collections.contacts[i].lastName;
				option.value = collections.contacts[i].id;
				txtRes.options.add(option);
				txtUserContact.options.add(option.cloneNode(true));
			}

			for (var i = 0, l = collections.locations.length; i < l; i++)
			{
				var option = document.createElement("OPTION");
				option.text = collections.locations[i].name;
				option.value = collections.locations[i].id;
				txtRes.options.add(option);
				txtUserLocation.options.add(option.cloneNode(true));
			}

			for (var i = 0, l = collections.tasks.length; i < l; i++)
			{
				var option = document.createElement("OPTION");
				option.text = collections.tasks[i].subject;
				option.value = collections.tasks[i].id;
				txtRes.options.add(option);
			}

			for (var i = 0, l = collections.resources.length; i < l; i++)
			{
				var option = document.createElement("OPTION");
				option.text = collections.resources[i].name;
				option.value = collections.resources[i].id;
				txtRes.options.add(option);
			}

			var controlsRow = $get('controlsRow');
			if (controlsRow)
			{
				if (sender.get_currentView() == MindFusion.Scheduling.CalendarView.ResourceView
				&& sender.get_groupType() === MindFusion.Scheduling.GroupType.None)
				{
					if (!$get('disableOverlay'))
					{
						var disabledOverlay = $mindfusion('<div id="disableOverlay" style="z-index: 500;position: absolute;background-color: #c0c0c0; opacity: 0.2;"></div>')[0];
						var b = Sys.UI.DomElement.getBounds(controlsRow);
						disabledOverlay.style.width = b.width + 'px';
						disabledOverlay.style.height = b.height + 'px';
						disabledOverlay.style.top = b.y + 'px';
						disabledOverlay.style.left = b.x + 'px';
						disabledOverlay.title = 'To enable the controls, turn on grouping for the Calendar.';
						$mindfusion(document.body).append(disabledOverlay);
					}
					alert('To enable the controls in the bottom, turn on grouping for the Calendar.');
				}
				else
				{
					if ($get('disableOverlay'))
					{
						$mindfusion(document.body).remove($get('disableOverlay'));
					}
				}
			}
		}

		// the DateClick event is raised when the user clicks a view cell.
		function onDateClick(sender, args)
		{
			var cal = $find('Calendar1');
			var txtInfo = $get('txtInfo');

			// get the clicked cell.
			var cell = args.get_cell();

			// display the count of items in the clicked cell. 
			// cue items are the items which are placed in the specified cell, but are hidden due to a lack of space.
			txtInfo.value = '';
			txtInfo.value = String.format('Items count in cell is {0} \n', cal.getCellItems(cell).length)
			txtInfo.value += String.format('Cue items count in cell is {0} \n', cal.getCueCellItems(cell).length);

			// display the count of header and header cue items in the clicked cell. These methods are available only in Timetable view.
			if (cal.getCurrentView() == MindFusion.Scheduling.CalendarView.Timetable)
			{
				var columnIndex = cell.columnIndex;
				txtInfo.value += String.format('Header items count in column is {0} \n', cal.getHeaderItems(columnIndex).length);
				txtInfo.value += String.format('Cue header items count in column is {0} \n', cal.getCueHeaderItems(columnIndex).length);
			}
		}

		// the Click event is raised when the user clicks within the bounds of the Calendar control.
		function onCalendarClick(sender, args)
		{
			var cal = $find('Calendar1');

			// exit if the click occured on a popup form.
			if ($mindfusion(args.target).parents('div.WebPlannerPopupFormSilver').length > 0)
				return;

			// get the cell located in the specified coordinates.
			// style the border of the cell object's background cell.
			if ($get('chkGetCell').checked)
			{
				var cell = cal.getCellAt(args.clientX, args.clientY);
				if (cell && cell.bgCell)
				{
					var innerCell;
					if (cal.get_currentView() == MindFusion.Scheduling.CalendarView.Timetable)
					{
						innerCell = $mindfusion(cell.bgCell).children()[0];
					}
					else
					{
						innerCell = cell.bgCell;
					}
					if (innerCell)
					{
						innerCell.style.border = '1px solid yellow';
					}
				}
			}
		}

		function Button1_onclick()
		{
			var cal = $find('Calendar1');
			var txtStart = $get('txtStartDate');
			var txtStartTime = $get('txtStartTime');
			var txtRes = $get('txtResources');
			var chkEnd = $get('chkEndTime');

			var start = dateFromString(txtStart.value, txtStartTime.value);

			// get the resource object by the specified id.
			var resource = cal.getResourceById(txtRes.value);

			// get the view cell that corresponds to the specified time and resource.
			// style the border of the cell object's background cell.
			var cell = cal.getTimeCell(start, chkEnd.checked, resource);
			if (cell && cell.bgCell)
			{

				var innerCell;
				if (cal.get_currentView() == MindFusion.Scheduling.CalendarView.Timetable)
				{
					innerCell = $mindfusion(cell.bgCell).children()[0];
				}
				else
				{
					innerCell = cell.bgCell;
				}
				if (innerCell)
				{
					innerCell.style.border = '1px solid red';
				}
			}
		}

		function Button2_onclick()
		{
			var cal = $find('Calendar1');
			var txtStart = $get('txtStartDate');
			var txtStartTime = $get('txtStartTime');
			var txtEnd = $get('txtEndDate');
			var txtEndTime = $get('txtEndTime');
			var txtRes = $get('txtResources');
			var chkEnd = $get('chkEndTime');

			var start = dateFromString(txtStart.value, txtStartTime.value);
			var end = dateFromString(txtEnd.value, txtEndTime.value);

			// get the resource object by the specified id.
			var resource = cal.getResourceById(txtRes.value);

			// get the collection of cells that correspond to the specified time and resource.
			// style the borders of the cells object's background cells.
			var cells = cal.getTimeCells(start, end, chkEnd.checked, resource);
			if (cells != null)
			{
				for (var i = 0, l = cells.length; i < l; i++)
				{
					if (cells[i].bgCell)
					{

						var innerCell;
						if (cal.get_currentView() == MindFusion.Scheduling.CalendarView.Timetable)
						{
							innerCell = $mindfusion(cells[i].bgCell).children()[0];
						}
						else
						{
							innerCell = cells[i].bgCell;
						}
						if (innerCell)
						{
							innerCell.style.border = '1px solid red';
						}
					}
				}
			}
		}

		function Button13_onclick()
		{
			var cal = $find('Calendar1');
			var txtStart = $get('txtStartDate');
			var txtStartTime = $get('txtStartTime');
			var txtEnd = $get('txtEndDate');
			var txtEndTime = $get('txtEndTime');
			var txtRes = $get('txtResources');

			var start = dateFromString(txtStart.value, txtStartTime.value);
			var end = dateFromString(txtEnd.value, txtEndTime.value);

			// get the resource object by the specified id.
			var resource = cal.getResourceById(txtRes.value);

			// get the collection of all day cells that correspond to the specified time and resource.
			// this method is applicable only in Timetable view and will return an empty array in other views.
			var cells = cal.getAllDayCells(start, end, resource);
			if (cells != null)
			{
				for (var i = 0, l = cells.length; i < l; i++)
				{
					if (cells[i].bgCell)
					{
						cells[i].bgCell.style.border = '1px solid red';
					}
				}
			}
		}

		function Button3_onclick()
		{
			var cal = $find('Calendar1');

			// get the Calendar's current selection.
			var selection = cal.getSelection();
			if (selection.start && selection.end)
				alert(String.format('Current selection is from {0} to {1}', selection.start.toString('dd.MM.yyyy'), selection.end.toString('dd.MM.yyyy')));
			else
				alert('Current selection is empty');
		}

		function Button5_onclick()
		{
			var cal = $find('Calendar1');

			// get all view cells in the current view.
			var cells = cal.getViewCells();
			if (cells != null)
			{
				for (var i = 0, l = cells.length; i < l; i++)
				{
					if (cells[i].bgCell)
					{

						var innerCell;
						if (cal.get_currentView() == MindFusion.Scheduling.CalendarView.Timetable)
						{
							innerCell = $mindfusion(cells[i].bgCell).children()[0];
						}
						else
						{
							innerCell = cells[i].bgCell;
						}
						if (innerCell)
						{
							innerCell.style.border = '';
						}
					}
				}
			}

			// get all all day cells in the current view.
			// this method is applicable only in Timetable view and will return an empty array in other views.
			var cells = cal.getAllDayCells();
			if (cells != null)
			{
				for (var i = 0, l = cells.length; i < l; i++)
				{
					if (cells[i].bgCell)
					{
						cells[i].bgCell.style.border = '';
					}
				}
			}
		}

		function Button4_onclick()
		{
			var cal = $find('Calendar1');
			var txtStart = $get('txtStartDate');
			var txtStartTime = $get('txtStartTime');
			var txtEnd = $get('txtEndDate');
			var txtEndTime = $get('txtEndTime');
			var txtRes = $get('txtResources');

			var start = dateFromString(txtStart.value, txtStartTime.value);
			var end = dateFromString(txtEnd.value, txtEndTime.value);

			// get the resource object by the specified id.
			var resource = cal.getResourceById(txtRes.value);

			// set the Calendar's selection.
			cal.setSelection(start, end, resource);
		}

		function Button6_onclick()
		{
			var cal = $find('Calendar1');
			// clear the Calendar's selection.
			cal.clearSelection();
		}

		function Button7_onclick()
		{
			var cal = $find('Calendar1');
			var txtStart = $get('txtStartDate');
			var txtStartTime = $get('txtStartTime');
			var txtEnd = $get('txtEndDate');
			var txtEndTime = $get('txtEndTime');
			var txtUserContact = $get('txtUserContact');
			var txtUserLocation = $get('txtUserLocation');

			// create an object, containing the data for the new item.
			var data = {
				startTime: dateFromString(txtStart.value, txtStartTime.value),
				endTime: dateFromString(txtEnd.value, txtEndTime.value),
				subject: "client created item",
				location: txtUserLocation.value != '' ? txtUserLocation.value : null,
				contacts: (txtUserContact.value != '') ? [txtUserContact.value] : []
			}
			// create the item.
			cal.createItem(data);
		}

		function Button8_onclick()
		{
			var cal = $find('Calendar1');
			var txtStart = $get('txtStartDate');
			var txtStartTime = $get('txtStartTime');
			var txtEnd = $get('txtEndDate');
			var txtEndTime = $get('txtEndTime');
			var txtUserContact = $get('txtUserContact');
			var txtUserLocation = $get('txtUserLocation');

			// create an object, containing the data for the new item.
			var masterData = {
				startTime: dateFromString(txtStart.value, txtStartTime.value),
				endTime: dateFromString(txtEnd.value, txtEndTime.value),
				subject: 'client recurrent item',
				location: txtUserLocation.value != '' ? txtUserLocation.value : null,
				contacts: (txtUserContact.value != '') ? [txtUserContact.value] : []
			}

			// create an object, containing the data for the recurrence
			var recData = {
				startDate: dateFromString(txtStart.value, txtStartTime.value),
				pattern: MindFusion.Scheduling.RecurrencePattern.Daily,
				dailyRecurrence: MindFusion.Scheduling.DailyRecurrence.EveryWorkday,
				recurrenceEnd: MindFusion.Scheduling.RecurrenceEnd.NumOccurrences,
				numOccurrences: 15
			};

			// create the recurrence object;
			var recurrence = new MindFusion.Scheduling.Recurrence(recData);
			// associate the recurrence data with the item data.
			masterData.recurrence = recurrence;

			// create the item
			cal.createItem(masterData);
		}

		function Button9_onclick()
		{
			var cal = $find('Calendar1');
			var txtStart = $get('txtStartDate');
			var txtStartTime = $get('txtStartTime');
			var txtEnd = $get('txtEndDate');
			var txtEndTime = $get('txtEndTime');
			var txtUserContact = $get('txtUserContact');
			var txtUserLocation = $get('txtUserLocation');

			// create an object, containing the data for the item.
			var data = {
				startTime: dateFromString(txtStart.value, txtStartTime.value),
				endTime: dateFromString(txtEnd.value, txtEndTime.value),
				subject: 'edited item',
				location: txtUserLocation.value,
				contacts: [txtUserContact.value]
			}

			// get the currently selected item.
			var selection = cal.getItemSelection();
			if (selection.length > 0)
			{
				var item = selection[0];

				// edit the item. 
				// the property values defined in the data object will be applied to the edited item. 
				// the rest of item's properties will remain unchanged.
				cal.editItem(item, data);
			} else
				alert('Select the item to be edited');
		}

		function Button10_onclick()
		{
			var cal = $find('Calendar1');

			// get the currently selected item.
			var selection = cal.getItemSelection();
			if (selection.length > 0)
			{
				var item = selection[0];

				//delete the item.
				cal.deleteItem(item);
			} else
				alert('Select the item to be deleted');
		}

		function Button11_onclick()
		{
			var cal = $find('Calendar1');

			// get the currently selected item.
			var selection = cal.getItemSelection();
			if (selection.length > 0)
			{
				var item = selection[0];

				// clone the item.
				cal.cloneItem(item);
			} else
				alert('Select the item to be cloned');
		}

		function Button14_onclick()
		{
			var cal = $find('Calendar1');

			// postback the control.
			cal.postback();
		}

	</script>
	</form>
</body>
</html>
